`timescale 1ns/1ps

module testbench_2();

localparam DELAY = 10;

reg Clk, Rst_n, En;
reg [0:15] DataIn;
wire [0:4] DataOut;

reg [0:15]  data [0:19];

// clock
always #DELAY Clk = ! Clk;



// initial 
initial begin
    Clk = 1'b1;
    Rst_n = 1'b0;
    En = 1'b0;
    DataIn = 'd0;
    $readmemh("./data/Data2.txt", data); //read data 
    # 20
    Rst_n = 1'b1;
    # 10
    En = 1'b1;
end


//main
integer j,file;
initial begin
    file = $fopen("result2.txt", "w+");
    # 20;
    for(j = 0;j < 20;j = j + 1) begin
        DataIn = data[j];
        # 10
        if(j != 0)
            $fwrite(file, "%dth input data = 16'b%b, output data = 5'd%d\n", j, data[j - 1], DataOut);
        # 10;
    end
    # 10 
    $fwrite(file, "%dth input data = 15'b%b, output data = 5'd%d\n", j, data[j - 1], DataOut);
    En = 1'b0;
    $fclose(file);
    $display("20 datas are testd over\n");
    $finish;
end



//
NumberOfPrefixZero Zero(
    .Clk(Clk),
    .Rst_n(Rst_n),
    .En(En),
    .DataIn(DataIn),
    .DataOut(DataOut)
);

endmodule 
